package ai.guiji.live.app.observer;

import java.util.ArrayList;
import java.util.List;

public class RefreshRoomListManager implements IObservable<Object> {

    private final List<IObserver<Object>> list = new ArrayList<>();

    private static RefreshRoomListManager instance;

    public static RefreshRoomListManager getInstance() {
        if (instance == null) {
            instance = new RefreshRoomListManager();
        }
        return instance;
    }

    @Override
    public void add(IObserver<Object> observer) {
        list.add(observer);
    }

    @Override
    public void remove(IObserver<Object> observer) {
        list.remove(observer);
    }

    @Override
    public void clear() {
        list.clear();
    }

    @Override
    public void notify(String message, Object obj) {
        for (IObserver<Object> item : list) {
            item.update(message, obj);
        }
    }


}
