package ai.guiji.live.app.pojo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * 选择的数字人信息
 * {"code":200,"msg":"处理成功","success":true,"data":{"pageSize":100,"pageNo":1,"totalPage":1,"totalRecord":31,"records":[{"id":5355,"robotName":"宁飘0630","robotCode":"434111063015493","robotType":3,"version":0,"division":"","coverUrl":"\/model\/2023\/06\/30\/5b9eaa6088a22512f0ab7f772e44e415.jpg","zipCoverUrl":"\/model\/2023\/06\/30\/5b9eaa6088a22512f0ab7f772e44e415.jpg","profilePicUrl":"\/model\/2023\/06\/30\/2fa6d99e005eb2a657313a9850803ea8.jpg","videoCoverUrl":null,"anchorCardList":[],"baseCode":null,"ttsSpeaker":"","face":null,"faceUrl":null,"latentUrl":null,"groupId":null,"orderNo":null,"status":1,"shareType":null,"robotDesc":null,"supportType":3,"greenClothUrl":"","boneFileUrl":"","showFlag":1,"gender":2,"age":null,"fakePopularity":0,"fakeSales":0,"starSigns":null,"delFlag":0,"createTime":"2023-06-30 18:22:29","updateTime":"2023-06-30 18:22:29","sceneApplicationTypes":[2,1],"originalCoverUrl":"\/model\/2023\/06\/30\/5b9eaa6088a22512f0ab7f772e44e415.jpg","sceneList":null,"flag":null,"expireTime":null,"days":null,"unit":null,"feeProductIds":null,"feeCreateTime":null,"feeUpdateTime":null,"trainStatus":null,"trainComment":null,"trainUploadId":null,"labelBaseDTOList":[],"setMealSize":1,"price":0,"periodDesc":"永久","chargeType":0,"sold":0,"owned":0,"isCollect":null},{"id":5354,"robotName":"宁飘0630","robotCode":"434111056384069","robotType":3,"version":0,"division":"","coverUrl":"\/model\/2023\/06\/30\/5b9eaa6088a22512f0ab7f772e44e415.jpg","zipCoverUrl":"\/model\/2023\/06\/30\/5b9eaa6088a22512f0ab7f772e44e415.jpg","profilePicUrl":"\/model\/2023\/06\/30\/dfcc38555b382297e96dfb92b012f497.jpg","videoCoverUrl":null,"anchorCardList":[],"baseCode":null,"ttsSpeaker":"","face":null,"faceUrl":null,"latentUrl":null,"groupId":null,"orderNo":null,"status":1,"shareType":null,"robotDesc":null,"supportType":3,"greenClothUrl":"","boneFileUrl":"","showFlag":1,"gender":2,"age":null,"fakePopularity":0,"fakeSales":0,"starSigns":null,"delFlag":0,"createTime":"2023-06-30 18:22:28","updateTime":"2023-06-30 18:22:28","sceneApplicationTypes":null,"originalCoverUrl":"\/model\/2023\/06\/30\/5b9eaa6088a22512f0ab7f772e44e415.jpg","sceneList":null,"flag":null,"expireTime":null,"days":null,"unit":null,"feeProductIds":null,"feeCreateTime":null,"feeUpdateTime":null,"trainStatus":null,"trainComment":null,"trainUploadId":null,"labelBaseDTOList":[],"setMealSize":1,"price":0,"periodDesc":"永久","chargeType":0,"sold":0,"owned":0,"isCollect":null},{"id":5230,"robotName":"约旦","robotCode":"428792204767301","robotType":3,"version":0,"division":"","coverUrl":"\/model\/2023\/06\/15\/7dd46570d81ecc3044787eab6d9f45cc.jpg","zipCoverUrl":"\/model\/2023\/06\/15\/7dd46570d81ecc3044787eab6d9f45cc.jpg","profilePicUrl":null,"videoCoverUrl":"\/model\/2023\/06\/15\/fe5124b02ce3a84460efbcc51617ae32.png","anchorCardList":[],"baseCode":null,"ttsSpeaker":"","face":null,"faceUrl":null,"latentUrl":null,"groupId":2,"orderNo":null,"status":1,"shareType":1,"robotDesc":null,"supportType":3,"greenClothUrl":"","boneFileUrl":"","showFlag":0,"gender":1,"age":31,"fakePopularity":0,"fakeSales":0,"starSigns":5,"delFlag":0,"createTime":"2023-06-15 17:40:05","updateTime":"2023-06-15 17:40:05","sceneApplicationTypes":[1],"originalCoverUrl":"\/model\/2023\/06\/15\/7dd46570d81ecc3044787eab6d9f45cc.jpg","sceneList":null,"flag":null,"expireTime":null,"days":null,"unit":null,"feeProductIds":null,"feeCreateTime":null,"feeUpdateTime":null,"trainStatus":null,"trainComment":null,"trainUploadId":null,"labelBaseDTOList":[],"setMealSize":4,"price":0,"periodDesc":"永久","chargeType":1,"sold":0,"owned":0,"isCollect":null},{"id":5227,"robotName":"三生","robotCode":"428762328707141","robotType":3,"version":0,"division":"","coverUrl":"\/model\/2023\/06\/15\/7759ff73f82642cae274b7cb0d27a629.jpg","zipCoverUrl":"\/model\/2023\/06\/15\/7759ff73f82642cae274b7cb0d27a629.jpg","profilePicUrl":"\/model\/2023\/06\/15\/8c68a5cce2caa9dfd37897f77185b1ab.jpg","videoCoverUrl":"\/model\/2023\/06\/15\/71b6c2873ad15d8408f88e6d00feefa7.png","anchorCardList":[]
 */
public class DigitalManInfo implements Serializable {

    public int id;
    public String robotName;
    public String robotCode;
    public String coverUrl;
    public int delFlag;     // 删除标记，0 表示未删除

    public List<SceneInfo> sceneList;       // 场景列表

    public boolean select;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        DigitalManInfo that = (DigitalManInfo) o;
        return id == that.id && Objects.equals(robotName, that.robotName);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, robotName);
    }

    public static List<DigitalManInfo> debug() {
        List<DigitalManInfo> list = new ArrayList<>();
        DigitalManInfo item1 = new DigitalManInfo();
        item1.id = 1;
        item1.robotName = "123";
        item1.coverUrl = "";
        DigitalManInfo item2 = new DigitalManInfo();
        item2.id = 2;
        item2.robotName = "456";
        item2.coverUrl = "";
        list.add(item1);
        list.add(item2);
        return list;
    }


    @Override
    public String toString() {
        return "DigitalManInfo{" +
                "id=" + id +
                ", robotName='" + robotName + '\'' +
                ", robotCode='" + robotCode + '\'' +
                ", coverUrl='" + coverUrl + '\'' +
                ", sceneList='" + sceneList + '\'' +
                ", delFlag=" + delFlag +
                ", select=" + select +
                '}';
    }
}
