package ai.guiji.live.app.pojo;

import android.text.TextUtils;

import org.json.JSONException;
import org.json.JSONObject;

import ai.guiji.live.app.App;
import ai.guiji.live.app.Constant;

/**
 * 音色信息
 */
public class TimbreInfo {

    public String ttsSpeaker;
    public int ttsSource;
    public String userCategory;     // 用这个表示男声女声吗？
    public String name;
    public String ttsCover;
    public String ttsAudition;      // 试听

    public double volume = 0;       // 音量
    public double speed = 0;  // 语速
    public double intonation = 0;   // 音调


    public int volumeMin = -20;
    public int volumeMax = 20;
    public int speedMin = -20;
    public int speedMax = 20;
    public int intonationMin = -20;
    public int intonationMax = 20;


    public static TimbreInfo parseJson(JSONObject jsonObject){
        TimbreInfo timbreInfo = new TimbreInfo();
        timbreInfo.ttsSpeaker = jsonObject.optString("ttsSpeaker");
        timbreInfo.ttsSource = jsonObject.optInt("ttsSource");
        timbreInfo.name = jsonObject.optString("ttsName");
        timbreInfo.ttsCover = jsonObject.optString("ttsCover");
        timbreInfo.ttsAudition = jsonObject.optString("ttsAudition");
        timbreInfo.userCategory = jsonObject.optString("userCategory");

        JSONObject ttsPlatForm = jsonObject.optJSONObject("ttsPlatForm");
        if (ttsPlatForm != null){
            timbreInfo.volumeMin = ttsPlatForm.optInt("volumeMin");
            timbreInfo.volumeMax = ttsPlatForm.optInt("volumeMax");
            timbreInfo.speedMin = ttsPlatForm.optInt("speedMin");
            timbreInfo.speedMax = ttsPlatForm.optInt("speedMax");
            timbreInfo.intonationMin = ttsPlatForm.optInt("intonationMin");
            timbreInfo.intonationMax = ttsPlatForm.optInt("intonationMax");

            String extendJson = ttsPlatForm.optString("extendJson");
            try {
                JSONObject extendJsonObject = new JSONObject(extendJson);
                timbreInfo.volume = extendJsonObject.optDouble("volume");
                timbreInfo.speed = extendJsonObject.optDouble("speed");
                timbreInfo.intonation = extendJsonObject.optDouble("intonation");
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }
        return timbreInfo;
    }

    @Override
    public String toString() {
        return "TimbreInfo{" +
                "ttsSpeaker='" + ttsSpeaker + '\'' +
                ", ttsSource=" + ttsSource +
                ", userCategory='" + userCategory + '\'' +
                ", name='" + name + '\'' +
                ", ttsCover='" + ttsCover + '\'' +
                ", ttsAudition='" + ttsAudition + '\'' +
                ", volume=" + volume +
                ", speed=" + speed +
                ", intonation=" + intonation +
                ", volumeMin=" + volumeMin +
                ", volumeMax=" + volumeMax +
                ", speedMin=" + speedMin +
                ", speedMax=" + speedMax +
                ", intonationMin=" + intonationMin +
                ", intonationMax=" + intonationMax +
                '}';
    }
}
