package ai.guiji.live.app.ui.activity.test

import ai.guiji.live.app.R
import ai.guiji.live.app.ui.activity.BaseActivity
import android.media.MediaPlayer
import android.media.audiofx.PresetReverb
import android.os.Bundle
import android.util.Log
import kotlinx.android.synthetic.main.activity_audio_play.*


class AudioPlayActivity : BaseActivity() {

    var mMediaPlayer: MediaPlayer? = null
    var mPresetReverb: PresetReverb? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_audio_play)
        mMediaPlayer = MediaPlayer()
        mMediaPlayer?.setVolume(1.0f, 1.0f)
        mMediaPlayer?.isLooping = false
        mMediaPlayer?.setOnPreparedListener {
            mMediaPlayer?.start()
        }
        mMediaPlayer?.setOnCompletionListener {
            Log.e(TAG, "OnCompletion")

        }
        mMediaPlayer?.setOnErrorListener { _, what, extra ->
            Log.e(TAG, "onError what: $what extra: $extra")
            false
        }

        mPresetReverb = PresetReverb(0, 0)
        mPresetReverb?.preset = PresetReverb.PRESET_NONE
        mPresetReverb?.enabled = true


        btn_audio_play.setOnClickListener {
            if (mMediaPlayer?.isPlaying == true) {
                mMediaPlayer?.stop()
            }
            mMediaPlayer?.reset()
            try {
//                https://tts.guiji.ai/source/chumen/caicai_meet.wav
//                https://tts.guiji.ai/source/ziyan/ziyan_chunchun.wav
                mMediaPlayer?.setDataSource("/storage/emulated/0/Android/data/ai.guiji.live.app/files/tmp/4.MP3")
//                mMediaPlayer?.setDataSource("https://tts.guiji.ai/source/chumen/caicai_meet.wav")

                val effectId = mPresetReverb?.id

                Log.e("123", "effectId: $effectId")
                mMediaPlayer?.attachAuxEffect(effectId?:0)
                mMediaPlayer?.setAuxEffectSendLevel(1.0f)

                mMediaPlayer?.prepareAsync()
            } catch (e: Exception) {
                Log.e(TAG, "setDataSource error: $e")
            }
        }

        btn_room0.setOnClickListener {
            mPresetReverb?.preset = PresetReverb.PRESET_NONE
            tv_reverb.text = "No reverb or reflections"
        }
        btn_room1.setOnClickListener {
            mPresetReverb?.preset = PresetReverb.PRESET_SMALLROOM
            tv_reverb.text = "Reverb preset representing a small room less than five meters in length"
        }
        btn_room2.setOnClickListener {
            mPresetReverb?.preset = PresetReverb.PRESET_MEDIUMROOM
            tv_reverb.text = "Reverb preset representing a medium room with a length of ten meters or less"
        }
        btn_room3.setOnClickListener {
            mPresetReverb?.preset = PresetReverb.PRESET_LARGEROOM
            tv_reverb.text = "Reverb preset representing a large-sized room suitable for live performances"
        }
        btn_room4.setOnClickListener {
            mPresetReverb?.preset = PresetReverb.PRESET_MEDIUMHALL
            tv_reverb.text = "Reverb preset representing a medium-sized hall"
        }
        btn_room5.setOnClickListener {
            mPresetReverb?.preset = PresetReverb.PRESET_LARGEHALL
            tv_reverb.text = "Reverb preset representing a large-sized hall suitable for a full orchestra"
        }
        btn_room6.setOnClickListener {
            mPresetReverb?.preset = PresetReverb.PRESET_PLATE
            tv_reverb.text = "Reverb preset representing a synthesis of the traditional plate reverb"
        }

    }

    override fun onDestroy() {
        super.onDestroy()
        mMediaPlayer?.release()
        mPresetReverb?.release()
    }

}