package ai.guiji.live.app.ui.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import java.util.List;

import ai.guiji.live.app.R;
import ai.guiji.live.app.pojo.AudioFolderInfo;

/**
 * 文件名：AudioFolderAdapter
 * 描述：音频文件夹
 */
public class AudioFolderAdapter extends RecyclerView.Adapter<AudioFolderAdapter.PagerAdapterHolder> {

    Context mContext;
    List<AudioFolderInfo> mFolder;
    FolderSelectedListener listener;

    public AudioFolderAdapter(Context context, List<AudioFolderInfo> folder, FolderSelectedListener listener) {
        mContext = context;
        mFolder = folder;
        this.listener = listener;
    }

    @NonNull
    @Override
    public PagerAdapterHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new PagerAdapterHolder(LayoutInflater.from(mContext)
                .inflate(R.layout.item_audio_folder, parent, false)
        );
    }

    @Override
    public void onBindViewHolder(@NonNull PagerAdapterHolder holder, int position) {
        AudioFolderInfo bean = mFolder.get(position);

        //名称
        holder.tv_name.setText(bean.getFolderName());
        //名称
        holder.tv_count.setText(mContext.getString(R.string.tv_choose_audio_count, null != bean.getAudioList() ?
                bean.getAudioList().size() : 0));
        holder.itemView.setOnClickListener(v -> listener.onClick(bean));
    }

    @Override
    public int getItemCount() {
        return mFolder == null ? 0 : mFolder.size();
    }

    static class PagerAdapterHolder extends RecyclerView.ViewHolder {

        ImageView img_dir;
        TextView tv_name, tv_count;

        public PagerAdapterHolder(@NonNull View itemView) {
            super(itemView);
            img_dir = itemView.findViewById(R.id.img_dir);
            tv_name = itemView.findViewById(R.id.tv_name);
            tv_count = itemView.findViewById(R.id.tv_count);
        }
    }

    public interface FolderSelectedListener {
        void onClick(AudioFolderInfo item);
    }
}
