package ai.guiji.live.app.ui.adapter

import ai.guiji.live.app.App
import ai.guiji.live.app.R
import ai.guiji.live.app.pojo.RoomInfo
import android.annotation.SuppressLint
import android.content.Context
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import jp.wasabeef.glide.transformations.BlurTransformation
import kotlinx.android.synthetic.main.item_main_live_room.view.*

class RoomAdapter(
    private val mContext: Context, private val mRoomListener: RoomListener?
) : RecyclerView.Adapter<RoomAdapter.ViewHolder>() {

    private var mList = ArrayList<RoomInfo>()

    class ViewHolder(view: View) : RecyclerView.ViewHolder(view)

    @SuppressLint("NotifyDataSetChanged")
    fun setData(list: ArrayList<RoomInfo>?) {
        mList.clear()
        list?.let { mList.addAll(list) }
        notifyDataSetChanged()
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(
            LayoutInflater.from(parent.context)
                .inflate(R.layout.item_main_live_room, parent, false)
        )
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        mList[position].apply {
            holder.itemView.tv_name.text = liveName
            holder.itemView.tv_model_name.text = robotName
            holder.itemView.tv_update_time.text = updatedTime
            holder.itemView.tv_id.text = mContext.getString(R.string.id_left, id)
            Glide.with(mContext).load(App.addBaseUrl(coverUrl)).placeholder(R.mipmap.bg_item_live_default)
                .error(R.mipmap.bg_item_live_default).into(holder.itemView.iv_img)
            Glide.with(mContext).load(App.addBaseUrl(coverUrl))
                .transform(BlurTransformation(25, 4)).into(holder.itemView.iv_fuzzy)

            holder.itemView.setOnClickListener {
                mRoomListener?.onClickItem(
                    position, this
                )
            }
        }
    }

    override fun getItemCount(): Int {
        return mList.size
    }

    interface RoomListener {
        fun onClickItem(position: Int, item: RoomInfo)

    }
}