package ai.guiji.live.app.ui.adapter

import ai.guiji.live.app.R
import ai.guiji.live.app.pojo.AudioPlayInfo
import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import kotlinx.android.synthetic.main.item_script.view.*

class ScriptAdapter(
    val mContext: Context, val mListener: ScriptListener
) : RecyclerView.Adapter<ScriptAdapter.ViewHolder>() {

    private var mList = ArrayList<AudioPlayInfo>()

    class ViewHolder(view: View) : RecyclerView.ViewHolder(view)

    @SuppressLint("NotifyDataSetChanged")
    fun setData(list: ArrayList<AudioPlayInfo>) {
        mList.clear()
        mList.addAll(list)
        notifyDataSetChanged()
    }

    @SuppressLint("NotifyDataSetChanged")
    fun refresh() {
        notifyDataSetChanged()
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(
            LayoutInflater.from(parent.context)
                .inflate(R.layout.item_script, parent, false)
        )
    }

    @SuppressLint("SetTextI18n")
    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        mList[position].apply {
            if (type == AudioPlayInfo.TYPE_AUDIO) {
                holder.itemView.tv_name.text = cacheName
                holder.itemView.tv_duration.text = "${(duration / 1000).toInt()}s"
            } else {
                holder.itemView.tv_name.text = text
                holder.itemView.tv_duration.text = "${text.length}字"
            }
            holder.itemView.setOnClickListener { mListener.onSelect(position, this) }
            holder.itemView.layout_content.setOnClickListener {
                if (type == AudioPlayInfo.TYPE_AUDIO) {
                    mListener.onSelect(position, this)
                } else {
                    mListener.onEdit(position, this)
                }
            }
            holder.itemView.layout_remove.setOnClickListener { mListener.onRemove(position, this) }
            if (playing) {
                Glide.with(mContext).load(R.mipmap.playing_gif).into(holder.itemView.iv_left)
            } else {
                Glide.with(mContext).load(R.mipmap.iv_script_play).into(holder.itemView.iv_left)
            }

        }
    }

    override fun getItemCount(): Int {
        return mList.size
    }

    interface ScriptListener {
        fun onRemove(position: Int, info: AudioPlayInfo)
        fun onSelect(position: Int, info: AudioPlayInfo)
        fun onEdit(position: Int, info: AudioPlayInfo)
    }
}