package ai.guiji.live.app.ui.adapter

import ai.guiji.live.app.App
import ai.guiji.live.app.Constant
import ai.guiji.live.app.R
import ai.guiji.live.app.pojo.DigitalManInfo
import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import kotlinx.android.synthetic.main.item_select_digital_man.view.*

class SelectDigitalManAdapter(
    val mContext: Context, val mListener: DigitalManListener
) : RecyclerView.Adapter<SelectDigitalManAdapter.ViewHolder>() {

    private var mList = ArrayList<DigitalManInfo>()

    class ViewHolder(view: View) : RecyclerView.ViewHolder(view)

    @SuppressLint("NotifyDataSetChanged")
    fun setData(list: ArrayList<DigitalManInfo>?) {
        mList.clear()
        list?.let {
            mList.addAll(it)
        }
        notifyDataSetChanged()
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(
            LayoutInflater.from(parent.context)
                .inflate(R.layout.item_select_digital_man, parent, false)
        )
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        mList[position].apply {
            Glide.with(mContext).load(App.addBaseUrl(coverUrl)).into(holder.itemView.iv_cover)
            holder.itemView.tv_name.text = robotName

            holder.itemView.setOnClickListener {
                mListener.onSelect(
                    position,
                    this
                )
            }
            holder.itemView.iv_select.visibility = if (select) View.VISIBLE else View.INVISIBLE
        }
    }

    override fun getItemCount(): Int {
        return mList.size
    }

    interface DigitalManListener {
        fun onSelect(position: Int, item: DigitalManInfo)
    }
}