package ai.guiji.live.app.ui.adapter

import ai.guiji.live.app.R
import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import kotlinx.android.synthetic.main.item_select_digital_man_tab.view.*

class SelectDigitalManTabAdapter(
    val mContext: Context,
    var mContentList: ArrayList<String>,
    private val mListener: Listener?
) :
    RecyclerView.Adapter<SelectDigitalManTabAdapter.ViewHolder>() {
    private var mCurrentPosition = 0

    class ViewHolder(view: View) : RecyclerView.ViewHolder(view)

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(
            LayoutInflater.from(parent.context)
                .inflate(R.layout.item_select_digital_man_tab, parent, false)
        )
    }

    @SuppressLint("NotifyDataSetChanged")
    fun setPosition(position: Int) {
        mCurrentPosition = position
        notifyDataSetChanged()
    }

    override fun onBindViewHolder(holder: ViewHolder, @SuppressLint("RecyclerView") position: Int) {
        mContentList[position].apply {
            holder.itemView.tv_name.text = this
            if (mCurrentPosition == position) {
                holder.itemView.tv_name.setTextColor(mContext.resources.getColor(R.color.white))
                holder.itemView.view_tag.visibility = View.VISIBLE
            } else {
                holder.itemView.tv_name.setTextColor(mContext.resources.getColor(R.color.color_80ffffff))
                holder.itemView.view_tag.visibility = View.GONE
            }
            holder.itemView.setOnClickListener {
                mListener?.onItemClick(position)
            }
        }
    }

    override fun getItemCount(): Int = mContentList.size

    interface Listener {
        fun onItemClick(position: Int)
    }
}