package ai.guiji.live.app.ui.adapter

import ai.guiji.live.app.App
import ai.guiji.live.app.Constant
import ai.guiji.live.app.R
import ai.guiji.live.app.pojo.TimbreInfo
import android.annotation.SuppressLint
import android.content.Context
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import kotlinx.android.synthetic.main.item_timbre.view.*

class TimbreAdapter(
    val mContext: Context, val mListener: TimbreListener
) : RecyclerView.Adapter<TimbreAdapter.ViewHolder>() {

    private var mList = ArrayList<TimbreInfo>()

    class ViewHolder(view: View) : RecyclerView.ViewHolder(view)

    @SuppressLint("NotifyDataSetChanged")
    fun setData(list: ArrayList<TimbreInfo>) {
        mList.clear()
        mList.addAll(list)
        notifyDataSetChanged()
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(
            LayoutInflater.from(parent.context)
                .inflate(R.layout.item_timbre, parent, false)
        )
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        mList[position].apply {
            Glide.with(mContext).load(App.addBaseUrl(ttsCover)).into(holder.itemView.iv_cover)
            holder.itemView.tv_name.text = name
            holder.itemView.setOnClickListener {
                mListener.onSelect(
                    position,
                    this
                )
            }
        }
    }



    override fun getItemCount(): Int {
        return mList.size
    }

    interface TimbreListener {
        fun onSelect(position: Int, item: TimbreInfo)
    }
}