package ai.guiji.live.app.ui.dialog

import ai.guiji.live.app.R
import ai.guiji.live.app.ui.activity.BaseActivity
import android.app.Dialog
import android.os.Bundle
import android.view.Gravity
import android.view.ViewGroup
import android.view.Window
import com.bumptech.glide.Glide
import kotlinx.android.synthetic.main.dialog_loading_live.*


class LoadingLiveDialog(
    private val mContext: BaseActivity, val mListener: ClickListener
) : Dialog(mContext, R.style.dialog_bottom) {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        requestWindowFeature(Window.FEATURE_NO_TITLE)
        setContentView(R.layout.dialog_loading_live)



        tv_cancel.setOnClickListener {
            mListener.onCancel()
            dismiss()
        }

        Glide.with(mContext).asGif().load(R.mipmap.iv_live_loading).into(iv_loading)

        window?.let {
            it.setGravity(Gravity.CENTER)
            it.setLayout(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT)
        }
        setCancelable(false)
        setCanceledOnTouchOutside(false)
    }

    interface ClickListener {
        fun onCancel()
    }
}