package ai.guiji.live.app.ui.dialog

import ai.guiji.live.app.R
import ai.guiji.live.app.ui.activity.BaseActivity
import android.app.Dialog
import android.os.Bundle
import android.view.Gravity
import android.view.ViewGroup
import android.view.Window
import android.view.animation.AnimationUtils
import android.view.animation.LinearInterpolator
import kotlinx.android.synthetic.main.dialog_loading_progress.*


class LoadingProgressDialog(
    private val mContext: BaseActivity, private val content: String? = null
) : Dialog(mContext, R.style.dialog_bottom) {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        requestWindowFeature(Window.FEATURE_NO_TITLE)
        setContentView(R.layout.dialog_loading_progress)

        val animation = AnimationUtils.loadAnimation(mContext, R.anim.rotate)
        val lin = LinearInterpolator()
        animation.interpolator = lin
        iv_loading.startAnimation(animation)

        content?.let {
            tv_loading.text = content
        } ?: let {
            tv_loading.text = mContext.getString(R.string.loading)
        }

        window?.let {
            it.setGravity(Gravity.CENTER)
            it.setLayout(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT)
        }
        setCancelable(false)
        setCanceledOnTouchOutside(false)
    }
}