package ai.guiji.live.app.ui.dialog

import ai.guiji.live.app.R
import ai.guiji.live.app.ui.activity.BaseActivity
import android.app.Dialog
import android.content.ClipData
import android.content.ClipboardManager
import android.content.Context
import android.os.Bundle
import android.view.Gravity
import android.view.ViewGroup
import android.view.Window
import android.widget.Toast
import androidx.core.content.ContextCompat.getSystemService
import kotlinx.android.synthetic.main.dialog_rtmp_address.*


class RTMPAddressDialog(
    private val mContext: BaseActivity,
    private val address: String
) : Dialog(mContext, R.style.dialog_bottom) {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        requestWindowFeature(Window.FEATURE_NO_TITLE)
        setContentView(R.layout.dialog_rtmp_address)

        tv_sure.setOnClickListener {
            dismiss()
        }
        tv_copy.setOnClickListener {
            copyAddress()
        }
        tv_address.text = address

        window?.let {
            it.setGravity(Gravity.BOTTOM) //设置显示在底部
            it.setLayout(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT)
        }
        setCancelable(false)
        setCanceledOnTouchOutside(false)
    }

    private fun copyAddress() {
        val clipboardManager =
            mContext.getSystemService(Context.CLIPBOARD_SERVICE) as ClipboardManager?
        val mClipData = ClipData.newPlainText("Name", tv_address.text)
        clipboardManager?.setPrimaryClip(mClipData)
        Toast.makeText(mContext, "复制成功", Toast.LENGTH_SHORT).show()
    }

}