package ai.guiji.live.app.ui.dialog

import ai.guiji.live.app.R
import ai.guiji.live.app.ui.activity.BaseActivity
import android.app.Dialog
import android.os.Bundle
import android.view.Gravity
import android.view.ViewGroup
import android.view.Window
import kotlinx.android.synthetic.main.dialog_script_type.*


class ScriptTypeDialog(
    private val mContext: BaseActivity,
    var mListener: ScriptTypeListener
) : Dialog(mContext, R.style.dialog_bottom) {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        requestWindowFeature(Window.FEATURE_NO_TITLE)
        setContentView(R.layout.dialog_script_type)

        tv_cancel.setOnClickListener {
            dismiss()
        }
        layout_audio.setOnClickListener {
            dismiss()
            mListener.onAudio()
        }
        layout_text.setOnClickListener {
            dismiss()
            mListener.onText()
        }

        window?.let {
            it.setGravity(Gravity.BOTTOM) //设置显示在底部
            it.setLayout(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT)
        }
        setCancelable(true)
        setCanceledOnTouchOutside(true)
    }


    interface ScriptTypeListener {
        fun onAudio()
        fun onText()
    }

}