package ai.guiji.live.app.util;

import android.graphics.Rect;
import android.view.TouchDelegate;
import android.view.View;

public class ClickListenerUtil {
    public static final int LIMIT_TIME = 400;

    private static long lastClickTime = 0;

    public static boolean canClick() {
        long curTime = System.currentTimeMillis();

        if (curTime - lastClickTime > LIMIT_TIME) {
            lastClickTime = curTime;
            return true;
        }
        return false;
    }

    public static boolean canClick(int interval) {
        long curTime = System.currentTimeMillis();

        if (curTime - lastClickTime > (interval > 0 ? interval : LIMIT_TIME)) {
            lastClickTime = curTime;
            return true;
        }
        return false;
    }

    public static void addClickRect(View view, int vertica, int horizontal) {
        Rect bounds = new Rect();
        // 获取View2占据的矩形区域在其父View（也就是View1）中的相对坐标
        view.getHitRect(bounds);
        ((View) view.getParent()).setTouchDelegate(new TouchDelegate(new Rect(
                bounds.left - horizontal, bounds.top - vertica,
                bounds.right + horizontal, bounds.bottom + vertica
        ), view));
    }
}
